package net.tsz.afinal.bitmap.core;

import android.content.Context;

/**
 * 用于判断当前系统的版本
 * 
 * @author michael yang 在sdk4.1下编译才能通过
 */
public class Utils {
	private Utils() {
	};

	
	/**
	 * 根据手机的分辨率从 dp 的单位 转成为 px(像素)
	 */
	public static int dip2px(Context context, float dpValue) {
		final float scale = context.getResources().getDisplayMetrics().density;
		return (int) (dpValue * scale + 0.5f);
	}

	/**
	 * 根据手机的分辨率从 px(像素) 的单位 转成为 dp
	 */
	public static int px2dip(Context context, float pxValue) {
		final float scale = context.getResources().getDisplayMetrics().density;
		return (int) (pxValue / scale + 0.5f);
	}
}
